# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['DatabaseRoleMemberArgs', 'DatabaseRoleMember']

@pulumi.input_type
class DatabaseRoleMemberArgs:
    def __init__(__self__, *,
                 member_id: pulumi.Input[str],
                 role_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a DatabaseRoleMember resource.
        :param pulumi.Input[str] member_id: Can be either user or role ID in format `<database_id>/<member_id>`. Can be retrieved using `SqlUser` or `mssql_database_member`.
        :param pulumi.Input[str] role_id: `<database_id>/<role_id>`
        """
        pulumi.set(__self__, "member_id", member_id)
        pulumi.set(__self__, "role_id", role_id)

    @property
    @pulumi.getter(name="memberId")
    def member_id(self) -> pulumi.Input[str]:
        """
        Can be either user or role ID in format `<database_id>/<member_id>`. Can be retrieved using `SqlUser` or `mssql_database_member`.
        """
        return pulumi.get(self, "member_id")

    @member_id.setter
    def member_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "member_id", value)

    @property
    @pulumi.getter(name="roleId")
    def role_id(self) -> pulumi.Input[str]:
        """
        `<database_id>/<role_id>`
        """
        return pulumi.get(self, "role_id")

    @role_id.setter
    def role_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "role_id", value)


@pulumi.input_type
class _DatabaseRoleMemberState:
    def __init__(__self__, *,
                 member_id: Optional[pulumi.Input[str]] = None,
                 role_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering DatabaseRoleMember resources.
        :param pulumi.Input[str] member_id: Can be either user or role ID in format `<database_id>/<member_id>`. Can be retrieved using `SqlUser` or `mssql_database_member`.
        :param pulumi.Input[str] role_id: `<database_id>/<role_id>`
        """
        if member_id is not None:
            pulumi.set(__self__, "member_id", member_id)
        if role_id is not None:
            pulumi.set(__self__, "role_id", role_id)

    @property
    @pulumi.getter(name="memberId")
    def member_id(self) -> Optional[pulumi.Input[str]]:
        """
        Can be either user or role ID in format `<database_id>/<member_id>`. Can be retrieved using `SqlUser` or `mssql_database_member`.
        """
        return pulumi.get(self, "member_id")

    @member_id.setter
    def member_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "member_id", value)

    @property
    @pulumi.getter(name="roleId")
    def role_id(self) -> Optional[pulumi.Input[str]]:
        """
        `<database_id>/<role_id>`
        """
        return pulumi.get(self, "role_id")

    @role_id.setter
    def role_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "role_id", value)


class DatabaseRoleMember(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 member_id: Optional[pulumi.Input[str]] = None,
                 role_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages database role membership.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_mssql as mssql
        import pulumiverse_mssql as mssql

        example_database = mssql.get_database(name="example")
        owner = mssql.get_sql_user(name="example_user",
            database_id=example_database.id)
        member = mssql.get_sql_user(name="member_user",
            database_id=example_database.id)
        example_database_role = mssql.DatabaseRole("exampleDatabaseRole",
            name="example",
            database_id=example_database.id,
            owner_id=owner.id)
        example_database_role_member = mssql.DatabaseRoleMember("exampleDatabaseRoleMember",
            role_id=example_database_role.id,
            member_id=member.id)
        ```

        ## Import

        import using <db_id>/<role_id> - can be retrieved using `SELECT CONCAT(DB_ID(), '/', DATABASE_PRINCIPAL_ID('<role_name>'), '/', DATABASE_PRINCIPAL_ID('<member_name'))`

        ```sh
         $ pulumi import mssql:index/databaseRoleMember:DatabaseRoleMember example '7/5/9'
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] member_id: Can be either user or role ID in format `<database_id>/<member_id>`. Can be retrieved using `SqlUser` or `mssql_database_member`.
        :param pulumi.Input[str] role_id: `<database_id>/<role_id>`
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DatabaseRoleMemberArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages database role membership.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_mssql as mssql
        import pulumiverse_mssql as mssql

        example_database = mssql.get_database(name="example")
        owner = mssql.get_sql_user(name="example_user",
            database_id=example_database.id)
        member = mssql.get_sql_user(name="member_user",
            database_id=example_database.id)
        example_database_role = mssql.DatabaseRole("exampleDatabaseRole",
            name="example",
            database_id=example_database.id,
            owner_id=owner.id)
        example_database_role_member = mssql.DatabaseRoleMember("exampleDatabaseRoleMember",
            role_id=example_database_role.id,
            member_id=member.id)
        ```

        ## Import

        import using <db_id>/<role_id> - can be retrieved using `SELECT CONCAT(DB_ID(), '/', DATABASE_PRINCIPAL_ID('<role_name>'), '/', DATABASE_PRINCIPAL_ID('<member_name'))`

        ```sh
         $ pulumi import mssql:index/databaseRoleMember:DatabaseRoleMember example '7/5/9'
        ```

        :param str resource_name: The name of the resource.
        :param DatabaseRoleMemberArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DatabaseRoleMemberArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 member_id: Optional[pulumi.Input[str]] = None,
                 role_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DatabaseRoleMemberArgs.__new__(DatabaseRoleMemberArgs)

            if member_id is None and not opts.urn:
                raise TypeError("Missing required property 'member_id'")
            __props__.__dict__["member_id"] = member_id
            if role_id is None and not opts.urn:
                raise TypeError("Missing required property 'role_id'")
            __props__.__dict__["role_id"] = role_id
        super(DatabaseRoleMember, __self__).__init__(
            'mssql:index/databaseRoleMember:DatabaseRoleMember',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            member_id: Optional[pulumi.Input[str]] = None,
            role_id: Optional[pulumi.Input[str]] = None) -> 'DatabaseRoleMember':
        """
        Get an existing DatabaseRoleMember resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] member_id: Can be either user or role ID in format `<database_id>/<member_id>`. Can be retrieved using `SqlUser` or `mssql_database_member`.
        :param pulumi.Input[str] role_id: `<database_id>/<role_id>`
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DatabaseRoleMemberState.__new__(_DatabaseRoleMemberState)

        __props__.__dict__["member_id"] = member_id
        __props__.__dict__["role_id"] = role_id
        return DatabaseRoleMember(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="memberId")
    def member_id(self) -> pulumi.Output[str]:
        """
        Can be either user or role ID in format `<database_id>/<member_id>`. Can be retrieved using `SqlUser` or `mssql_database_member`.
        """
        return pulumi.get(self, "member_id")

    @property
    @pulumi.getter(name="roleId")
    def role_id(self) -> pulumi.Output[str]:
        """
        `<database_id>/<role_id>`
        """
        return pulumi.get(self, "role_id")

