# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ServerRoleMemberArgs', 'ServerRoleMember']

@pulumi.input_type
class ServerRoleMemberArgs:
    def __init__(__self__, *,
                 member_id: pulumi.Input[str],
                 role_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a ServerRoleMember resource.
        :param pulumi.Input[str] member_id: ID of the member. Can be retrieved using `ServerRole` or `SqlLogin`
        :param pulumi.Input[str] role_id: ID of the server role. Can be retrieved using `ServerRole`
        """
        pulumi.set(__self__, "member_id", member_id)
        pulumi.set(__self__, "role_id", role_id)

    @property
    @pulumi.getter(name="memberId")
    def member_id(self) -> pulumi.Input[str]:
        """
        ID of the member. Can be retrieved using `ServerRole` or `SqlLogin`
        """
        return pulumi.get(self, "member_id")

    @member_id.setter
    def member_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "member_id", value)

    @property
    @pulumi.getter(name="roleId")
    def role_id(self) -> pulumi.Input[str]:
        """
        ID of the server role. Can be retrieved using `ServerRole`
        """
        return pulumi.get(self, "role_id")

    @role_id.setter
    def role_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "role_id", value)


@pulumi.input_type
class _ServerRoleMemberState:
    def __init__(__self__, *,
                 member_id: Optional[pulumi.Input[str]] = None,
                 role_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ServerRoleMember resources.
        :param pulumi.Input[str] member_id: ID of the member. Can be retrieved using `ServerRole` or `SqlLogin`
        :param pulumi.Input[str] role_id: ID of the server role. Can be retrieved using `ServerRole`
        """
        if member_id is not None:
            pulumi.set(__self__, "member_id", member_id)
        if role_id is not None:
            pulumi.set(__self__, "role_id", role_id)

    @property
    @pulumi.getter(name="memberId")
    def member_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the member. Can be retrieved using `ServerRole` or `SqlLogin`
        """
        return pulumi.get(self, "member_id")

    @member_id.setter
    def member_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "member_id", value)

    @property
    @pulumi.getter(name="roleId")
    def role_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the server role. Can be retrieved using `ServerRole`
        """
        return pulumi.get(self, "role_id")

    @role_id.setter
    def role_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "role_id", value)


class ServerRoleMember(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 member_id: Optional[pulumi.Input[str]] = None,
                 role_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages server role membership.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_mssql as mssql
        import pulumiverse_mssql as mssql

        member = mssql.get_sql_login(name="member_login")
        example_server_role = mssql.ServerRole("exampleServerRole", name="example")
        example_server_role_member = mssql.ServerRoleMember("exampleServerRoleMember",
            role_id=example_server_role.id,
            member_id=member.id)
        ```

        ## Import

        import using <role_id>/<member_id> - can be retrieved using `sys.server_principals` view

        ```sh
         $ pulumi import mssql:index/serverRoleMember:ServerRoleMember example '7/5'
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] member_id: ID of the member. Can be retrieved using `ServerRole` or `SqlLogin`
        :param pulumi.Input[str] role_id: ID of the server role. Can be retrieved using `ServerRole`
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ServerRoleMemberArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages server role membership.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_mssql as mssql
        import pulumiverse_mssql as mssql

        member = mssql.get_sql_login(name="member_login")
        example_server_role = mssql.ServerRole("exampleServerRole", name="example")
        example_server_role_member = mssql.ServerRoleMember("exampleServerRoleMember",
            role_id=example_server_role.id,
            member_id=member.id)
        ```

        ## Import

        import using <role_id>/<member_id> - can be retrieved using `sys.server_principals` view

        ```sh
         $ pulumi import mssql:index/serverRoleMember:ServerRoleMember example '7/5'
        ```

        :param str resource_name: The name of the resource.
        :param ServerRoleMemberArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ServerRoleMemberArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 member_id: Optional[pulumi.Input[str]] = None,
                 role_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ServerRoleMemberArgs.__new__(ServerRoleMemberArgs)

            if member_id is None and not opts.urn:
                raise TypeError("Missing required property 'member_id'")
            __props__.__dict__["member_id"] = member_id
            if role_id is None and not opts.urn:
                raise TypeError("Missing required property 'role_id'")
            __props__.__dict__["role_id"] = role_id
        super(ServerRoleMember, __self__).__init__(
            'mssql:index/serverRoleMember:ServerRoleMember',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            member_id: Optional[pulumi.Input[str]] = None,
            role_id: Optional[pulumi.Input[str]] = None) -> 'ServerRoleMember':
        """
        Get an existing ServerRoleMember resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] member_id: ID of the member. Can be retrieved using `ServerRole` or `SqlLogin`
        :param pulumi.Input[str] role_id: ID of the server role. Can be retrieved using `ServerRole`
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ServerRoleMemberState.__new__(_ServerRoleMemberState)

        __props__.__dict__["member_id"] = member_id
        __props__.__dict__["role_id"] = role_id
        return ServerRoleMember(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="memberId")
    def member_id(self) -> pulumi.Output[str]:
        """
        ID of the member. Can be retrieved using `ServerRole` or `SqlLogin`
        """
        return pulumi.get(self, "member_id")

    @property
    @pulumi.getter(name="roleId")
    def role_id(self) -> pulumi.Output[str]:
        """
        ID of the server role. Can be retrieved using `ServerRole`
        """
        return pulumi.get(self, "role_id")

